///////////////////Software Control Header///////////////////////////////////
// SingList.h - Demonstration of CSinglyList<>.
//
// $LogThisFile$ \Projects\UtilCode\TestCode\SingList\SingList.cpp
// 
// V01.00 07/03/2001 2236
//  Initial revision.
// 
// This code is freely distributed to help the development of complex
// software in any field using C++. The author is not held responsible
// for any damage caused by the usage of the code.
// The author should be acknowledged for the use of this piece of code in
// commercial software.
//
// Bug reports and suggestions are welcomed to report to
//
//          tzzstan@hotmail.com
/////////////////////////////////////////////////////////////////////////////
#include <stdio.h>

#include "TSingLst.h"
#include "SingList.h"

void main()
{
   printf("Singly list demonstration program\n"
          "=================================\n");

   CSinglyList<Pets> AllPets;
   while(1)
   {
      char buffer[80];
      printf("\n"
             "   1. Add pet - Dog\n"
             "   2. Add pet - Bird\n"
             "   3. Add pet - Fish\n"
             "   4. Remove all pets\n"
             "   5. Quit\n"
             "Your choice: ");

      int choice;
      gets(buffer);
      sscanf(buffer, "%d", &choice);

      // Process the input
		if(choice == 4)	// Clear pet's list
         AllPets.RemoveAll();
      else if(choice == 5)	// Illegal input
         return;
      else if(choice >= 1 && choice <= 3)	// Add new pet
      {
         printf("Your pet's name: ");
         gets(buffer);
         Pets newPet(buffer, choice - 1);
         AllPets.Insert(newPet);
      }

      printf("\n"
             "Your have %d pets including: \n",
             AllPets.Size());

      // Traverse the list and list out the pets
		for(AllPets.ResetPtr(); AllPets.IsValid(); AllPets.Next())
      {
         Pets *tmpPtr = AllPets.Current();
         printf("   %s named %s\n",
            tmpPtr->PetType(), tmpPtr->PetName());
      }
   }
}

